<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>8.4. collections.abc — Abstract Base Classes for Containers &mdash; Python 3.5.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/pydoctheme.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '3.5.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/sidebar.js"></script>
    <link rel="search" type="application/opensearchdescription+xml"
          title="Search within Python 3.5.1 documentation"
          href="../_static/opensearch.xml"/>
    <link rel="author" title="About these documents" href="../about.html" />
    <link rel="copyright" title="Copyright" href="../copyright.html" />
    <link rel="top" title="Python 3.5.1 documentation" href="../contents.html" />
    <link rel="up" title="8. Data Types" href="datatypes.html" />
    <link rel="next" title="8.5. heapq — Heap queue algorithm" href="heapq.html" />
    <link rel="prev" title="8.3. collections — Container datatypes" href="collections.html" />
    <link rel="shortcut icon" type="image/png" href="../_static/py.png" />
    <script type="text/javascript" src="../_static/copybutton.js"></script>
    <script type="text/javascript" src="../_static/version_switch.js"></script>
    
 

  </head>
  <body role="document">  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="heapq.html" title="8.5. heapq — Heap queue algorithm"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="collections.html" title="8.3. collections — Container datatypes"
             accesskey="P">previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="datatypes.html" accesskey="U">8. Data Types</a> &raquo;</li> 
      </ul>
    </div>    

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="module-collections.abc">
<span id="collections-abc-abstract-base-classes-for-containers"></span><h1>8.4. <a class="reference internal" href="#module-collections.abc" title="collections.abc: Abstract base classes for containers"><code class="xref py py-mod docutils literal"><span class="pre">collections.abc</span></code></a> &#8212; Abstract Base Classes for Containers<a class="headerlink" href="#module-collections.abc" title="Permalink to this headline">¶</a></h1>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.3: </span>Formerly, this module was part of the <a class="reference internal" href="collections.html#module-collections" title="collections: Container datatypes"><code class="xref py py-mod docutils literal"><span class="pre">collections</span></code></a> module.</p>
</div>
<p><strong>Source code:</strong> <a class="reference external" href="https://hg.python.org/cpython/file/3.5/Lib/_collections_abc.py">Lib/_collections_abc.py</a></p>
<hr class="docutils" />
<p>This module provides <a class="reference internal" href="../glossary.html#term-abstract-base-class"><span class="xref std std-term">abstract base classes</span></a> that
can be used to test whether a class provides a particular interface; for
example, whether it is hashable or whether it is a mapping.</p>
<div class="section" id="collections-abstract-base-classes">
<span id="id1"></span><h2>8.4.1. Collections Abstract Base Classes<a class="headerlink" href="#collections-abstract-base-classes" title="Permalink to this headline">¶</a></h2>
<p>The collections module offers the following <a class="reference internal" href="../glossary.html#term-abstract-base-class"><span class="xref std std-term">ABCs</span></a>:</p>
<table border="1" class="docutils">
<colgroup>
<col width="21%" />
<col width="18%" />
<col width="19%" />
<col width="42%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">ABC</th>
<th class="head">Inherits from</th>
<th class="head">Abstract Methods</th>
<th class="head">Mixin Methods</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td><a class="reference internal" href="#collections.abc.Container" title="collections.abc.Container"><code class="xref py py-class docutils literal"><span class="pre">Container</span></code></a></td>
<td>&nbsp;</td>
<td><code class="docutils literal"><span class="pre">__contains__</span></code></td>
<td>&nbsp;</td>
</tr>
<tr class="row-odd"><td><a class="reference internal" href="#collections.abc.Hashable" title="collections.abc.Hashable"><code class="xref py py-class docutils literal"><span class="pre">Hashable</span></code></a></td>
<td>&nbsp;</td>
<td><code class="docutils literal"><span class="pre">__hash__</span></code></td>
<td>&nbsp;</td>
</tr>
<tr class="row-even"><td><a class="reference internal" href="#collections.abc.Iterable" title="collections.abc.Iterable"><code class="xref py py-class docutils literal"><span class="pre">Iterable</span></code></a></td>
<td>&nbsp;</td>
<td><code class="docutils literal"><span class="pre">__iter__</span></code></td>
<td>&nbsp;</td>
</tr>
<tr class="row-odd"><td><a class="reference internal" href="#collections.abc.Iterator" title="collections.abc.Iterator"><code class="xref py py-class docutils literal"><span class="pre">Iterator</span></code></a></td>
<td><a class="reference internal" href="#collections.abc.Iterable" title="collections.abc.Iterable"><code class="xref py py-class docutils literal"><span class="pre">Iterable</span></code></a></td>
<td><code class="docutils literal"><span class="pre">__next__</span></code></td>
<td><code class="docutils literal"><span class="pre">__iter__</span></code></td>
</tr>
<tr class="row-even"><td><a class="reference internal" href="#collections.abc.Generator" title="collections.abc.Generator"><code class="xref py py-class docutils literal"><span class="pre">Generator</span></code></a></td>
<td><a class="reference internal" href="#collections.abc.Iterator" title="collections.abc.Iterator"><code class="xref py py-class docutils literal"><span class="pre">Iterator</span></code></a></td>
<td><code class="docutils literal"><span class="pre">send</span></code>, <code class="docutils literal"><span class="pre">throw</span></code></td>
<td><code class="docutils literal"><span class="pre">close</span></code>, <code class="docutils literal"><span class="pre">__iter__</span></code>, <code class="docutils literal"><span class="pre">__next__</span></code></td>
</tr>
<tr class="row-odd"><td><a class="reference internal" href="#collections.abc.Sized" title="collections.abc.Sized"><code class="xref py py-class docutils literal"><span class="pre">Sized</span></code></a></td>
<td>&nbsp;</td>
<td><code class="docutils literal"><span class="pre">__len__</span></code></td>
<td>&nbsp;</td>
</tr>
<tr class="row-even"><td><a class="reference internal" href="#collections.abc.Callable" title="collections.abc.Callable"><code class="xref py py-class docutils literal"><span class="pre">Callable</span></code></a></td>
<td>&nbsp;</td>
<td><code class="docutils literal"><span class="pre">__call__</span></code></td>
<td>&nbsp;</td>
</tr>
<tr class="row-odd"><td><a class="reference internal" href="#collections.abc.Sequence" title="collections.abc.Sequence"><code class="xref py py-class docutils literal"><span class="pre">Sequence</span></code></a></td>
<td><a class="reference internal" href="#collections.abc.Sized" title="collections.abc.Sized"><code class="xref py py-class docutils literal"><span class="pre">Sized</span></code></a>,
<a class="reference internal" href="#collections.abc.Iterable" title="collections.abc.Iterable"><code class="xref py py-class docutils literal"><span class="pre">Iterable</span></code></a>,
<a class="reference internal" href="#collections.abc.Container" title="collections.abc.Container"><code class="xref py py-class docutils literal"><span class="pre">Container</span></code></a></td>
<td><code class="docutils literal"><span class="pre">__getitem__</span></code>,
<code class="docutils literal"><span class="pre">__len__</span></code></td>
<td><code class="docutils literal"><span class="pre">__contains__</span></code>, <code class="docutils literal"><span class="pre">__iter__</span></code>, <code class="docutils literal"><span class="pre">__reversed__</span></code>,
<code class="docutils literal"><span class="pre">index</span></code>, and <code class="docutils literal"><span class="pre">count</span></code></td>
</tr>
<tr class="row-even"><td><a class="reference internal" href="#collections.abc.MutableSequence" title="collections.abc.MutableSequence"><code class="xref py py-class docutils literal"><span class="pre">MutableSequence</span></code></a></td>
<td><a class="reference internal" href="#collections.abc.Sequence" title="collections.abc.Sequence"><code class="xref py py-class docutils literal"><span class="pre">Sequence</span></code></a></td>
<td><code class="docutils literal"><span class="pre">__getitem__</span></code>,
<code class="docutils literal"><span class="pre">__setitem__</span></code>,
<code class="docutils literal"><span class="pre">__delitem__</span></code>,
<code class="docutils literal"><span class="pre">__len__</span></code>,
<code class="docutils literal"><span class="pre">insert</span></code></td>
<td>Inherited <a class="reference internal" href="#collections.abc.Sequence" title="collections.abc.Sequence"><code class="xref py py-class docutils literal"><span class="pre">Sequence</span></code></a> methods and
<code class="docutils literal"><span class="pre">append</span></code>, <code class="docutils literal"><span class="pre">reverse</span></code>, <code class="docutils literal"><span class="pre">extend</span></code>, <code class="docutils literal"><span class="pre">pop</span></code>,
<code class="docutils literal"><span class="pre">remove</span></code>, and <code class="docutils literal"><span class="pre">__iadd__</span></code></td>
</tr>
<tr class="row-odd"><td><a class="reference internal" href="#collections.abc.Set" title="collections.abc.Set"><code class="xref py py-class docutils literal"><span class="pre">Set</span></code></a></td>
<td><a class="reference internal" href="#collections.abc.Sized" title="collections.abc.Sized"><code class="xref py py-class docutils literal"><span class="pre">Sized</span></code></a>,
<a class="reference internal" href="#collections.abc.Iterable" title="collections.abc.Iterable"><code class="xref py py-class docutils literal"><span class="pre">Iterable</span></code></a>,
<a class="reference internal" href="#collections.abc.Container" title="collections.abc.Container"><code class="xref py py-class docutils literal"><span class="pre">Container</span></code></a></td>
<td><code class="docutils literal"><span class="pre">__contains__</span></code>,
<code class="docutils literal"><span class="pre">__iter__</span></code>,
<code class="docutils literal"><span class="pre">__len__</span></code></td>
<td><code class="docutils literal"><span class="pre">__le__</span></code>, <code class="docutils literal"><span class="pre">__lt__</span></code>, <code class="docutils literal"><span class="pre">__eq__</span></code>, <code class="docutils literal"><span class="pre">__ne__</span></code>,
<code class="docutils literal"><span class="pre">__gt__</span></code>, <code class="docutils literal"><span class="pre">__ge__</span></code>, <code class="docutils literal"><span class="pre">__and__</span></code>, <code class="docutils literal"><span class="pre">__or__</span></code>,
<code class="docutils literal"><span class="pre">__sub__</span></code>, <code class="docutils literal"><span class="pre">__xor__</span></code>, and <code class="docutils literal"><span class="pre">isdisjoint</span></code></td>
</tr>
<tr class="row-even"><td><a class="reference internal" href="#collections.abc.MutableSet" title="collections.abc.MutableSet"><code class="xref py py-class docutils literal"><span class="pre">MutableSet</span></code></a></td>
<td><a class="reference internal" href="#collections.abc.Set" title="collections.abc.Set"><code class="xref py py-class docutils literal"><span class="pre">Set</span></code></a></td>
<td><code class="docutils literal"><span class="pre">__contains__</span></code>,
<code class="docutils literal"><span class="pre">__iter__</span></code>,
<code class="docutils literal"><span class="pre">__len__</span></code>,
<code class="docutils literal"><span class="pre">add</span></code>,
<code class="docutils literal"><span class="pre">discard</span></code></td>
<td>Inherited <a class="reference internal" href="#collections.abc.Set" title="collections.abc.Set"><code class="xref py py-class docutils literal"><span class="pre">Set</span></code></a> methods and
<code class="docutils literal"><span class="pre">clear</span></code>, <code class="docutils literal"><span class="pre">pop</span></code>, <code class="docutils literal"><span class="pre">remove</span></code>, <code class="docutils literal"><span class="pre">__ior__</span></code>,
<code class="docutils literal"><span class="pre">__iand__</span></code>, <code class="docutils literal"><span class="pre">__ixor__</span></code>, and <code class="docutils literal"><span class="pre">__isub__</span></code></td>
</tr>
<tr class="row-odd"><td><a class="reference internal" href="#collections.abc.Mapping" title="collections.abc.Mapping"><code class="xref py py-class docutils literal"><span class="pre">Mapping</span></code></a></td>
<td><a class="reference internal" href="#collections.abc.Sized" title="collections.abc.Sized"><code class="xref py py-class docutils literal"><span class="pre">Sized</span></code></a>,
<a class="reference internal" href="#collections.abc.Iterable" title="collections.abc.Iterable"><code class="xref py py-class docutils literal"><span class="pre">Iterable</span></code></a>,
<a class="reference internal" href="#collections.abc.Container" title="collections.abc.Container"><code class="xref py py-class docutils literal"><span class="pre">Container</span></code></a></td>
<td><code class="docutils literal"><span class="pre">__getitem__</span></code>,
<code class="docutils literal"><span class="pre">__iter__</span></code>,
<code class="docutils literal"><span class="pre">__len__</span></code></td>
<td><code class="docutils literal"><span class="pre">__contains__</span></code>, <code class="docutils literal"><span class="pre">keys</span></code>, <code class="docutils literal"><span class="pre">items</span></code>, <code class="docutils literal"><span class="pre">values</span></code>,
<code class="docutils literal"><span class="pre">get</span></code>, <code class="docutils literal"><span class="pre">__eq__</span></code>, and <code class="docutils literal"><span class="pre">__ne__</span></code></td>
</tr>
<tr class="row-even"><td><a class="reference internal" href="#collections.abc.MutableMapping" title="collections.abc.MutableMapping"><code class="xref py py-class docutils literal"><span class="pre">MutableMapping</span></code></a></td>
<td><a class="reference internal" href="#collections.abc.Mapping" title="collections.abc.Mapping"><code class="xref py py-class docutils literal"><span class="pre">Mapping</span></code></a></td>
<td><code class="docutils literal"><span class="pre">__getitem__</span></code>,
<code class="docutils literal"><span class="pre">__setitem__</span></code>,
<code class="docutils literal"><span class="pre">__delitem__</span></code>,
<code class="docutils literal"><span class="pre">__iter__</span></code>,
<code class="docutils literal"><span class="pre">__len__</span></code></td>
<td>Inherited <a class="reference internal" href="#collections.abc.Mapping" title="collections.abc.Mapping"><code class="xref py py-class docutils literal"><span class="pre">Mapping</span></code></a> methods and
<code class="docutils literal"><span class="pre">pop</span></code>, <code class="docutils literal"><span class="pre">popitem</span></code>, <code class="docutils literal"><span class="pre">clear</span></code>, <code class="docutils literal"><span class="pre">update</span></code>,
and <code class="docutils literal"><span class="pre">setdefault</span></code></td>
</tr>
<tr class="row-odd"><td><a class="reference internal" href="#collections.abc.MappingView" title="collections.abc.MappingView"><code class="xref py py-class docutils literal"><span class="pre">MappingView</span></code></a></td>
<td><a class="reference internal" href="#collections.abc.Sized" title="collections.abc.Sized"><code class="xref py py-class docutils literal"><span class="pre">Sized</span></code></a></td>
<td>&nbsp;</td>
<td><code class="docutils literal"><span class="pre">__len__</span></code></td>
</tr>
<tr class="row-even"><td><a class="reference internal" href="#collections.abc.ItemsView" title="collections.abc.ItemsView"><code class="xref py py-class docutils literal"><span class="pre">ItemsView</span></code></a></td>
<td><a class="reference internal" href="#collections.abc.MappingView" title="collections.abc.MappingView"><code class="xref py py-class docutils literal"><span class="pre">MappingView</span></code></a>,
<a class="reference internal" href="#collections.abc.Set" title="collections.abc.Set"><code class="xref py py-class docutils literal"><span class="pre">Set</span></code></a></td>
<td>&nbsp;</td>
<td><code class="docutils literal"><span class="pre">__contains__</span></code>,
<code class="docutils literal"><span class="pre">__iter__</span></code></td>
</tr>
<tr class="row-odd"><td><a class="reference internal" href="#collections.abc.KeysView" title="collections.abc.KeysView"><code class="xref py py-class docutils literal"><span class="pre">KeysView</span></code></a></td>
<td><a class="reference internal" href="#collections.abc.MappingView" title="collections.abc.MappingView"><code class="xref py py-class docutils literal"><span class="pre">MappingView</span></code></a>,
<a class="reference internal" href="#collections.abc.Set" title="collections.abc.Set"><code class="xref py py-class docutils literal"><span class="pre">Set</span></code></a></td>
<td>&nbsp;</td>
<td><code class="docutils literal"><span class="pre">__contains__</span></code>,
<code class="docutils literal"><span class="pre">__iter__</span></code></td>
</tr>
<tr class="row-even"><td><a class="reference internal" href="#collections.abc.ValuesView" title="collections.abc.ValuesView"><code class="xref py py-class docutils literal"><span class="pre">ValuesView</span></code></a></td>
<td><a class="reference internal" href="#collections.abc.MappingView" title="collections.abc.MappingView"><code class="xref py py-class docutils literal"><span class="pre">MappingView</span></code></a></td>
<td>&nbsp;</td>
<td><code class="docutils literal"><span class="pre">__contains__</span></code>, <code class="docutils literal"><span class="pre">__iter__</span></code></td>
</tr>
<tr class="row-odd"><td><a class="reference internal" href="#collections.abc.Awaitable" title="collections.abc.Awaitable"><code class="xref py py-class docutils literal"><span class="pre">Awaitable</span></code></a></td>
<td>&nbsp;</td>
<td><code class="docutils literal"><span class="pre">__await__</span></code></td>
<td>&nbsp;</td>
</tr>
<tr class="row-even"><td><a class="reference internal" href="#collections.abc.Coroutine" title="collections.abc.Coroutine"><code class="xref py py-class docutils literal"><span class="pre">Coroutine</span></code></a></td>
<td><a class="reference internal" href="#collections.abc.Awaitable" title="collections.abc.Awaitable"><code class="xref py py-class docutils literal"><span class="pre">Awaitable</span></code></a></td>
<td><code class="docutils literal"><span class="pre">send</span></code>, <code class="docutils literal"><span class="pre">throw</span></code></td>
<td><code class="docutils literal"><span class="pre">close</span></code></td>
</tr>
<tr class="row-odd"><td><a class="reference internal" href="#collections.abc.AsyncIterable" title="collections.abc.AsyncIterable"><code class="xref py py-class docutils literal"><span class="pre">AsyncIterable</span></code></a></td>
<td>&nbsp;</td>
<td><code class="docutils literal"><span class="pre">__aiter__</span></code></td>
<td>&nbsp;</td>
</tr>
<tr class="row-even"><td><a class="reference internal" href="#collections.abc.AsyncIterator" title="collections.abc.AsyncIterator"><code class="xref py py-class docutils literal"><span class="pre">AsyncIterator</span></code></a></td>
<td><a class="reference internal" href="#collections.abc.AsyncIterable" title="collections.abc.AsyncIterable"><code class="xref py py-class docutils literal"><span class="pre">AsyncIterable</span></code></a></td>
<td><code class="docutils literal"><span class="pre">__anext__</span></code></td>
<td><code class="docutils literal"><span class="pre">__aiter__</span></code></td>
</tr>
</tbody>
</table>
<dl class="class">
<dt id="collections.abc.Container">
<em class="property">class </em><code class="descclassname">collections.abc.</code><code class="descname">Container</code><a class="headerlink" href="#collections.abc.Container" title="Permalink to this definition">¶</a></dt>
<dt id="collections.abc.Hashable">
<em class="property">class </em><code class="descclassname">collections.abc.</code><code class="descname">Hashable</code><a class="headerlink" href="#collections.abc.Hashable" title="Permalink to this definition">¶</a></dt>
<dt id="collections.abc.Sized">
<em class="property">class </em><code class="descclassname">collections.abc.</code><code class="descname">Sized</code><a class="headerlink" href="#collections.abc.Sized" title="Permalink to this definition">¶</a></dt>
<dt id="collections.abc.Callable">
<em class="property">class </em><code class="descclassname">collections.abc.</code><code class="descname">Callable</code><a class="headerlink" href="#collections.abc.Callable" title="Permalink to this definition">¶</a></dt>
<dd><p>ABCs for classes that provide respectively the methods <a class="reference internal" href="../reference/datamodel.html#object.__contains__" title="object.__contains__"><code class="xref py py-meth docutils literal"><span class="pre">__contains__()</span></code></a>,
<a class="reference internal" href="../reference/datamodel.html#object.__hash__" title="object.__hash__"><code class="xref py py-meth docutils literal"><span class="pre">__hash__()</span></code></a>, <a class="reference internal" href="../reference/datamodel.html#object.__len__" title="object.__len__"><code class="xref py py-meth docutils literal"><span class="pre">__len__()</span></code></a>, and <a class="reference internal" href="../reference/datamodel.html#object.__call__" title="object.__call__"><code class="xref py py-meth docutils literal"><span class="pre">__call__()</span></code></a>.</p>
</dd></dl>

<dl class="class">
<dt id="collections.abc.Iterable">
<em class="property">class </em><code class="descclassname">collections.abc.</code><code class="descname">Iterable</code><a class="headerlink" href="#collections.abc.Iterable" title="Permalink to this definition">¶</a></dt>
<dd><p>ABC for classes that provide the <a class="reference internal" href="../reference/datamodel.html#object.__iter__" title="object.__iter__"><code class="xref py py-meth docutils literal"><span class="pre">__iter__()</span></code></a> method.
See also the definition of <a class="reference internal" href="../glossary.html#term-iterable"><span class="xref std std-term">iterable</span></a>.</p>
</dd></dl>

<dl class="class">
<dt id="collections.abc.Iterator">
<em class="property">class </em><code class="descclassname">collections.abc.</code><code class="descname">Iterator</code><a class="headerlink" href="#collections.abc.Iterator" title="Permalink to this definition">¶</a></dt>
<dd><p>ABC for classes that provide the <a class="reference internal" href="stdtypes.html#iterator.__iter__" title="iterator.__iter__"><code class="xref py py-meth docutils literal"><span class="pre">__iter__()</span></code></a> and
<a class="reference internal" href="stdtypes.html#iterator.__next__" title="iterator.__next__"><code class="xref py py-meth docutils literal"><span class="pre">__next__()</span></code></a> methods.  See also the definition of
<a class="reference internal" href="../glossary.html#term-iterator"><span class="xref std std-term">iterator</span></a>.</p>
</dd></dl>

<dl class="class">
<dt id="collections.abc.Generator">
<em class="property">class </em><code class="descclassname">collections.abc.</code><code class="descname">Generator</code><a class="headerlink" href="#collections.abc.Generator" title="Permalink to this definition">¶</a></dt>
<dd><p>ABC for generator classes that implement the protocol defined in
<span class="target" id="index-0"></span><a class="pep reference external" href="https://www.python.org/dev/peps/pep-0342"><strong>PEP 342</strong></a> that extends iterators with the <a class="reference internal" href="../reference/expressions.html#generator.send" title="generator.send"><code class="xref py py-meth docutils literal"><span class="pre">send()</span></code></a>,
<a class="reference internal" href="../reference/expressions.html#generator.throw" title="generator.throw"><code class="xref py py-meth docutils literal"><span class="pre">throw()</span></code></a> and <a class="reference internal" href="../reference/expressions.html#generator.close" title="generator.close"><code class="xref py py-meth docutils literal"><span class="pre">close()</span></code></a> methods.
See also the definition of <a class="reference internal" href="../glossary.html#term-generator"><span class="xref std std-term">generator</span></a>.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.5.</span></p>
</div>
</dd></dl>

<dl class="class">
<dt id="collections.abc.Sequence">
<em class="property">class </em><code class="descclassname">collections.abc.</code><code class="descname">Sequence</code><a class="headerlink" href="#collections.abc.Sequence" title="Permalink to this definition">¶</a></dt>
<dt id="collections.abc.MutableSequence">
<em class="property">class </em><code class="descclassname">collections.abc.</code><code class="descname">MutableSequence</code><a class="headerlink" href="#collections.abc.MutableSequence" title="Permalink to this definition">¶</a></dt>
<dd><p>ABCs for read-only and mutable <a class="reference internal" href="../glossary.html#term-sequence"><span class="xref std std-term">sequences</span></a>.</p>
<p>Implementation note: Some of the mixin methods, such as
<a class="reference internal" href="../reference/datamodel.html#object.__iter__" title="object.__iter__"><code class="xref py py-meth docutils literal"><span class="pre">__iter__()</span></code></a>, <a class="reference internal" href="../reference/datamodel.html#object.__reversed__" title="object.__reversed__"><code class="xref py py-meth docutils literal"><span class="pre">__reversed__()</span></code></a> and <code class="xref py py-meth docutils literal"><span class="pre">index()</span></code>, make
repeated calls to the underlying <a class="reference internal" href="../reference/datamodel.html#object.__getitem__" title="object.__getitem__"><code class="xref py py-meth docutils literal"><span class="pre">__getitem__()</span></code></a> method.
Consequently, if <a class="reference internal" href="../reference/datamodel.html#object.__getitem__" title="object.__getitem__"><code class="xref py py-meth docutils literal"><span class="pre">__getitem__()</span></code></a> is implemented with constant
access speed, the mixin methods will have linear performance;
however, if the underlying method is linear (as it would be with a
linked list), the mixins will have quadratic performance and will
likely need to be overridden.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.5: </span>The index() method added support for <em>stop</em> and <em>start</em>
arguments.</p>
</div>
</dd></dl>

<dl class="class">
<dt id="collections.abc.Set">
<em class="property">class </em><code class="descclassname">collections.abc.</code><code class="descname">Set</code><a class="headerlink" href="#collections.abc.Set" title="Permalink to this definition">¶</a></dt>
<dt id="collections.abc.MutableSet">
<em class="property">class </em><code class="descclassname">collections.abc.</code><code class="descname">MutableSet</code><a class="headerlink" href="#collections.abc.MutableSet" title="Permalink to this definition">¶</a></dt>
<dd><p>ABCs for read-only and mutable sets.</p>
</dd></dl>

<dl class="class">
<dt id="collections.abc.Mapping">
<em class="property">class </em><code class="descclassname">collections.abc.</code><code class="descname">Mapping</code><a class="headerlink" href="#collections.abc.Mapping" title="Permalink to this definition">¶</a></dt>
<dt id="collections.abc.MutableMapping">
<em class="property">class </em><code class="descclassname">collections.abc.</code><code class="descname">MutableMapping</code><a class="headerlink" href="#collections.abc.MutableMapping" title="Permalink to this definition">¶</a></dt>
<dd><p>ABCs for read-only and mutable <a class="reference internal" href="../glossary.html#term-mapping"><span class="xref std std-term">mappings</span></a>.</p>
</dd></dl>

<dl class="class">
<dt id="collections.abc.MappingView">
<em class="property">class </em><code class="descclassname">collections.abc.</code><code class="descname">MappingView</code><a class="headerlink" href="#collections.abc.MappingView" title="Permalink to this definition">¶</a></dt>
<dt id="collections.abc.ItemsView">
<em class="property">class </em><code class="descclassname">collections.abc.</code><code class="descname">ItemsView</code><a class="headerlink" href="#collections.abc.ItemsView" title="Permalink to this definition">¶</a></dt>
<dt id="collections.abc.KeysView">
<em class="property">class </em><code class="descclassname">collections.abc.</code><code class="descname">KeysView</code><a class="headerlink" href="#collections.abc.KeysView" title="Permalink to this definition">¶</a></dt>
<dt id="collections.abc.ValuesView">
<em class="property">class </em><code class="descclassname">collections.abc.</code><code class="descname">ValuesView</code><a class="headerlink" href="#collections.abc.ValuesView" title="Permalink to this definition">¶</a></dt>
<dd><p>ABCs for mapping, items, keys, and values <a class="reference internal" href="../glossary.html#term-dictionary-view"><span class="xref std std-term">views</span></a>.</p>
</dd></dl>

<dl class="class">
<dt id="collections.abc.Awaitable">
<em class="property">class </em><code class="descclassname">collections.abc.</code><code class="descname">Awaitable</code><a class="headerlink" href="#collections.abc.Awaitable" title="Permalink to this definition">¶</a></dt>
<dd><p>ABC for <a class="reference internal" href="../glossary.html#term-awaitable"><span class="xref std std-term">awaitable</span></a> objects, which can be used in <a class="reference internal" href="../reference/expressions.html#await"><code class="xref std std-keyword docutils literal"><span class="pre">await</span></code></a>
expressions.  Custom implementations must provide the <a class="reference internal" href="../reference/datamodel.html#object.__await__" title="object.__await__"><code class="xref py py-meth docutils literal"><span class="pre">__await__()</span></code></a>
method.</p>
<p><a class="reference internal" href="../glossary.html#term-coroutine"><span class="xref std std-term">Coroutine</span></a> objects and instances of the
<a class="reference internal" href="#collections.abc.Coroutine" title="collections.abc.Coroutine"><code class="xref py py-class docutils literal"><span class="pre">Coroutine</span></code></a> ABC are all instances of this ABC.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">In CPython, generator-based coroutines (generators decorated with
<a class="reference internal" href="types.html#types.coroutine" title="types.coroutine"><code class="xref py py-func docutils literal"><span class="pre">types.coroutine()</span></code></a> or <a class="reference internal" href="asyncio-task.html#asyncio.coroutine" title="asyncio.coroutine"><code class="xref py py-func docutils literal"><span class="pre">asyncio.coroutine()</span></code></a>) are
<em>awaitables</em>, even though they do not have an <a class="reference internal" href="../reference/datamodel.html#object.__await__" title="object.__await__"><code class="xref py py-meth docutils literal"><span class="pre">__await__()</span></code></a> method.
Using <code class="docutils literal"><span class="pre">isinstance(gencoro,</span> <span class="pre">Awaitable)</span></code> for them will return <code class="docutils literal"><span class="pre">False</span></code>.
Use <a class="reference internal" href="inspect.html#inspect.isawaitable" title="inspect.isawaitable"><code class="xref py py-func docutils literal"><span class="pre">inspect.isawaitable()</span></code></a> to detect them.</p>
</div>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.5.</span></p>
</div>
</dd></dl>

<dl class="class">
<dt id="collections.abc.Coroutine">
<em class="property">class </em><code class="descclassname">collections.abc.</code><code class="descname">Coroutine</code><a class="headerlink" href="#collections.abc.Coroutine" title="Permalink to this definition">¶</a></dt>
<dd><p>ABC for coroutine compatible classes.  These implement the
following methods, defined in <a class="reference internal" href="../reference/datamodel.html#coroutine-objects"><span>Coroutine Objects</span></a>:
<a class="reference internal" href="../reference/datamodel.html#coroutine.send" title="coroutine.send"><code class="xref py py-meth docutils literal"><span class="pre">send()</span></code></a>, <a class="reference internal" href="../reference/datamodel.html#coroutine.throw" title="coroutine.throw"><code class="xref py py-meth docutils literal"><span class="pre">throw()</span></code></a>, and
<a class="reference internal" href="../reference/datamodel.html#coroutine.close" title="coroutine.close"><code class="xref py py-meth docutils literal"><span class="pre">close()</span></code></a>.  Custom implementations must also implement
<a class="reference internal" href="../reference/datamodel.html#object.__await__" title="object.__await__"><code class="xref py py-meth docutils literal"><span class="pre">__await__()</span></code></a>.  All <a class="reference internal" href="#collections.abc.Coroutine" title="collections.abc.Coroutine"><code class="xref py py-class docutils literal"><span class="pre">Coroutine</span></code></a> instances are also instances of
<a class="reference internal" href="#collections.abc.Awaitable" title="collections.abc.Awaitable"><code class="xref py py-class docutils literal"><span class="pre">Awaitable</span></code></a>.  See also the definition of <a class="reference internal" href="../glossary.html#term-coroutine"><span class="xref std std-term">coroutine</span></a>.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">In CPython, generator-based coroutines (generators decorated with
<a class="reference internal" href="types.html#types.coroutine" title="types.coroutine"><code class="xref py py-func docutils literal"><span class="pre">types.coroutine()</span></code></a> or <a class="reference internal" href="asyncio-task.html#asyncio.coroutine" title="asyncio.coroutine"><code class="xref py py-func docutils literal"><span class="pre">asyncio.coroutine()</span></code></a>) are
<em>awaitables</em>, even though they do not have an <a class="reference internal" href="../reference/datamodel.html#object.__await__" title="object.__await__"><code class="xref py py-meth docutils literal"><span class="pre">__await__()</span></code></a> method.
Using <code class="docutils literal"><span class="pre">isinstance(gencoro,</span> <span class="pre">Coroutine)</span></code> for them will return <code class="docutils literal"><span class="pre">False</span></code>.
Use <a class="reference internal" href="inspect.html#inspect.isawaitable" title="inspect.isawaitable"><code class="xref py py-func docutils literal"><span class="pre">inspect.isawaitable()</span></code></a> to detect them.</p>
</div>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.5.</span></p>
</div>
</dd></dl>

<dl class="class">
<dt id="collections.abc.AsyncIterable">
<em class="property">class </em><code class="descclassname">collections.abc.</code><code class="descname">AsyncIterable</code><a class="headerlink" href="#collections.abc.AsyncIterable" title="Permalink to this definition">¶</a></dt>
<dd><p>ABC for classes that provide <code class="docutils literal"><span class="pre">__aiter__</span></code> method.  See also the
definition of <a class="reference internal" href="../glossary.html#term-asynchronous-iterable"><span class="xref std std-term">asynchronous iterable</span></a>.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.5.</span></p>
</div>
</dd></dl>

<dl class="class">
<dt id="collections.abc.AsyncIterator">
<em class="property">class </em><code class="descclassname">collections.abc.</code><code class="descname">AsyncIterator</code><a class="headerlink" href="#collections.abc.AsyncIterator" title="Permalink to this definition">¶</a></dt>
<dd><p>ABC for classes that provide <code class="docutils literal"><span class="pre">__aiter__</span></code> and <code class="docutils literal"><span class="pre">__anext__</span></code>
methods.  See also the definition of <a class="reference internal" href="../glossary.html#term-asynchronous-iterator"><span class="xref std std-term">asynchronous iterator</span></a>.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.5.</span></p>
</div>
</dd></dl>

<p>These ABCs allow us to ask classes or instances if they provide
particular functionality, for example:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="n">size</span> <span class="o">=</span> <span class="k">None</span>
<span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">myvar</span><span class="p">,</span> <span class="n">collections</span><span class="o">.</span><span class="n">abc</span><span class="o">.</span><span class="n">Sized</span><span class="p">):</span>
    <span class="n">size</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">myvar</span><span class="p">)</span>
</pre></div>
</div>
<p>Several of the ABCs are also useful as mixins that make it easier to develop
classes supporting container APIs.  For example, to write a class supporting
the full <a class="reference internal" href="#collections.abc.Set" title="collections.abc.Set"><code class="xref py py-class docutils literal"><span class="pre">Set</span></code></a> API, it is only necessary to supply the three underlying
abstract methods: <a class="reference internal" href="../reference/datamodel.html#object.__contains__" title="object.__contains__"><code class="xref py py-meth docutils literal"><span class="pre">__contains__()</span></code></a>, <a class="reference internal" href="../reference/datamodel.html#object.__iter__" title="object.__iter__"><code class="xref py py-meth docutils literal"><span class="pre">__iter__()</span></code></a>, and <a class="reference internal" href="../reference/datamodel.html#object.__len__" title="object.__len__"><code class="xref py py-meth docutils literal"><span class="pre">__len__()</span></code></a>.
The ABC supplies the remaining methods such as <a class="reference internal" href="../reference/datamodel.html#object.__and__" title="object.__and__"><code class="xref py py-meth docutils literal"><span class="pre">__and__()</span></code></a> and
<code class="xref py py-meth docutils literal"><span class="pre">isdisjoint()</span></code>:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="k">class</span> <span class="nc">ListBasedSet</span><span class="p">(</span><span class="n">collections</span><span class="o">.</span><span class="n">abc</span><span class="o">.</span><span class="n">Set</span><span class="p">):</span>
     <span class="sd">&#39;&#39;&#39; Alternate set implementation favoring space over speed</span>
<span class="sd">         and not requiring the set elements to be hashable. &#39;&#39;&#39;</span>
     <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">iterable</span><span class="p">):</span>
         <span class="bp">self</span><span class="o">.</span><span class="n">elements</span> <span class="o">=</span> <span class="n">lst</span> <span class="o">=</span> <span class="p">[]</span>
         <span class="k">for</span> <span class="n">value</span> <span class="ow">in</span> <span class="n">iterable</span><span class="p">:</span>
             <span class="k">if</span> <span class="n">value</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">lst</span><span class="p">:</span>
                 <span class="n">lst</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">value</span><span class="p">)</span>
     <span class="k">def</span> <span class="nf">__iter__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
         <span class="k">return</span> <span class="nb">iter</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">elements</span><span class="p">)</span>
     <span class="k">def</span> <span class="nf">__contains__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">value</span><span class="p">):</span>
         <span class="k">return</span> <span class="n">value</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">elements</span>
     <span class="k">def</span> <span class="nf">__len__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
         <span class="k">return</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">elements</span><span class="p">)</span>

<span class="n">s1</span> <span class="o">=</span> <span class="n">ListBasedSet</span><span class="p">(</span><span class="s">&#39;abcdef&#39;</span><span class="p">)</span>
<span class="n">s2</span> <span class="o">=</span> <span class="n">ListBasedSet</span><span class="p">(</span><span class="s">&#39;defghi&#39;</span><span class="p">)</span>
<span class="n">overlap</span> <span class="o">=</span> <span class="n">s1</span> <span class="o">&amp;</span> <span class="n">s2</span>            <span class="c"># The __and__() method is supported automatically</span>
</pre></div>
</div>
<p>Notes on using <a class="reference internal" href="#collections.abc.Set" title="collections.abc.Set"><code class="xref py py-class docutils literal"><span class="pre">Set</span></code></a> and <a class="reference internal" href="#collections.abc.MutableSet" title="collections.abc.MutableSet"><code class="xref py py-class docutils literal"><span class="pre">MutableSet</span></code></a> as a mixin:</p>
<ol class="arabic simple">
<li>Since some set operations create new sets, the default mixin methods need
a way to create new instances from an iterable. The class constructor is
assumed to have a signature in the form <code class="docutils literal"><span class="pre">ClassName(iterable)</span></code>.
That assumption is factored-out to an internal classmethod called
<code class="xref py py-meth docutils literal"><span class="pre">_from_iterable()</span></code> which calls <code class="docutils literal"><span class="pre">cls(iterable)</span></code> to produce a new set.
If the <a class="reference internal" href="#collections.abc.Set" title="collections.abc.Set"><code class="xref py py-class docutils literal"><span class="pre">Set</span></code></a> mixin is being used in a class with a different
constructor signature, you will need to override <code class="xref py py-meth docutils literal"><span class="pre">_from_iterable()</span></code>
with a classmethod that can construct new instances from
an iterable argument.</li>
<li>To override the comparisons (presumably for speed, as the
semantics are fixed), redefine <a class="reference internal" href="../reference/datamodel.html#object.__le__" title="object.__le__"><code class="xref py py-meth docutils literal"><span class="pre">__le__()</span></code></a> and <a class="reference internal" href="../reference/datamodel.html#object.__ge__" title="object.__ge__"><code class="xref py py-meth docutils literal"><span class="pre">__ge__()</span></code></a>,
then the other operations will automatically follow suit.</li>
<li>The <a class="reference internal" href="#collections.abc.Set" title="collections.abc.Set"><code class="xref py py-class docutils literal"><span class="pre">Set</span></code></a> mixin provides a <code class="xref py py-meth docutils literal"><span class="pre">_hash()</span></code> method to compute a hash value
for the set; however, <a class="reference internal" href="../reference/datamodel.html#object.__hash__" title="object.__hash__"><code class="xref py py-meth docutils literal"><span class="pre">__hash__()</span></code></a> is not defined because not all sets
are hashable or immutable.  To add set hashability using mixins,
inherit from both <a class="reference internal" href="#collections.abc.Set" title="collections.abc.Set"><code class="xref py py-meth docutils literal"><span class="pre">Set()</span></code></a> and <a class="reference internal" href="#collections.abc.Hashable" title="collections.abc.Hashable"><code class="xref py py-meth docutils literal"><span class="pre">Hashable()</span></code></a>, then define
<code class="docutils literal"><span class="pre">__hash__</span> <span class="pre">=</span> <span class="pre">Set._hash</span></code>.</li>
</ol>
<div class="admonition seealso">
<p class="first admonition-title">See also</p>
<ul class="last simple">
<li><a class="reference external" href="http://code.activestate.com/recipes/576694/">OrderedSet recipe</a> for an
example built on <a class="reference internal" href="#collections.abc.MutableSet" title="collections.abc.MutableSet"><code class="xref py py-class docutils literal"><span class="pre">MutableSet</span></code></a>.</li>
<li>For more about ABCs, see the <a class="reference internal" href="abc.html#module-abc" title="abc: Abstract base classes according to PEP 3119."><code class="xref py py-mod docutils literal"><span class="pre">abc</span></code></a> module and <span class="target" id="index-1"></span><a class="pep reference external" href="https://www.python.org/dev/peps/pep-3119"><strong>PEP 3119</strong></a>.</li>
</ul>
</div>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../contents.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">8.4. <code class="docutils literal"><span class="pre">collections.abc</span></code> &#8212; Abstract Base Classes for Containers</a><ul>
<li><a class="reference internal" href="#collections-abstract-base-classes">8.4.1. Collections Abstract Base Classes</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="collections.html"
                        title="previous chapter">8.3. <code class="docutils literal"><span class="pre">collections</span></code> &#8212; Container datatypes</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="heapq.html"
                        title="next chapter">8.5. <code class="docutils literal"><span class="pre">heapq</span></code> &#8212; Heap queue algorithm</a></p>
<h3>This Page</h3>
<ul class="this-page-menu">
  <li><a href="../bugs.html">Report a Bug</a></li>
  <li><a href="../_sources/library/collections.abc.txt"
         rel="nofollow">Show Source</a></li>
</ul>

<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="heapq.html" title="8.5. heapq — Heap queue algorithm"
             >next</a> |</li>
        <li class="right" >
          <a href="collections.html" title="8.3. collections — Container datatypes"
             >previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="datatypes.html" >8. Data Types</a> &raquo;</li> 
      </ul>
    </div>  
    <div class="footer">
    &copy; <a href="../copyright.html">Copyright</a> 1990-2016, Python Software Foundation.
    <br />
    The Python Software Foundation is a non-profit corporation.
    <a href="https://www.python.org/psf/donations/">Please donate.</a>
    <br />
    Last updated on Jan 08, 2016.
    <a href="../bugs.html">Found a bug</a>?
    <br />
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.3.3.
    </div>

  </body>
</html>